<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "https://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
<meta http-equiv="X-UA-Compatible" content="IE=9"/>
<meta name="generator" content="Doxygen 1.8.18"/>
<meta name="viewport" content="width=device-width, initial-scale=1"/>
<title>XHXKit: XHXKit/Classes/General/Category/UIView+KKLBadgeView.m 源文件</title>
<link href="tabs.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="jquery.js"></script>
<script type="text/javascript" src="dynsections.js"></script>
<link href="navtree.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="resize.js"></script>
<script type="text/javascript" src="navtreedata.js"></script>
<script type="text/javascript" src="navtree.js"></script>
<link href="search/search.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="search/searchdata.js"></script>
<script type="text/javascript" src="search/search.js"></script>
<link href="doxygen.css" rel="stylesheet" type="text/css" />
</head>
<body>
<div id="top"><!-- do not remove this div, it is closed by doxygen! -->
<div id="titlearea">
<table cellspacing="0" cellpadding="0">
 <tbody>
 <tr style="height: 56px;">
  <td id="projectalign" style="padding-left: 0.5em;">
   <div id="projectname">XHXKit
   &#160;<span id="projectnumber">4.10.0.12</span>
   </div>
  </td>
 </tr>
 </tbody>
</table>
</div>
<!-- end header part -->
<!-- 制作者 Doxygen 1.8.18 -->
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:cf05388f2679ee054f2beb29a391d25f4e673ac3&amp;dn=gpl-2.0.txt GPL-v2 */
var searchBox = new SearchBox("searchBox", "search",false,'搜索');
/* @license-end */
</script>
<script type="text/javascript" src="menudata.js"></script>
<script type="text/javascript" src="menu.js"></script>
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:cf05388f2679ee054f2beb29a391d25f4e673ac3&amp;dn=gpl-2.0.txt GPL-v2 */
$(function() {
  initMenu('',true,false,'search.php','搜索');
  $(document).ready(function() { init_search(); });
});
/* @license-end */</script>
<div id="main-nav"></div>
</div><!-- top -->
<div id="side-nav" class="ui-resizable side-nav-resizable">
  <div id="nav-tree">
    <div id="nav-tree-contents">
      <div id="nav-sync" class="sync"></div>
    </div>
  </div>
  <div id="splitbar" style="-moz-user-select:none;" 
       class="ui-resizable-handle">
  </div>
</div>
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:cf05388f2679ee054f2beb29a391d25f4e673ac3&amp;dn=gpl-2.0.txt GPL-v2 */
$(document).ready(function(){initNavTree('_u_i_view_09_k_k_l_badge_view_8m_source.html',''); initResizable(); });
/* @license-end */
</script>
<div id="doc-content">
<!-- window showing the filter options -->
<div id="MSearchSelectWindow"
     onmouseover="return searchBox.OnSearchSelectShow()"
     onmouseout="return searchBox.OnSearchSelectHide()"
     onkeydown="return searchBox.OnSearchSelectKey(event)">
</div>

<!-- iframe showing the search results (closed by default) -->
<div id="MSearchResultsWindow">
<iframe src="javascript:void(0)" frameborder="0" 
        name="MSearchResults" id="MSearchResults">
</iframe>
</div>

<div class="header">
  <div class="headertitle">
<div class="title">UIView+KKLBadgeView.m</div>  </div>
</div><!--header-->
<div class="contents">
<a href="_u_i_view_09_k_k_l_badge_view_8m.html">浏览该文件的文档.</a><div class="fragment"><div class="line"><a name="l00001"></a><span class="lineno">    1</span>&#160;<span class="comment">//</span></div>
<div class="line"><a name="l00002"></a><span class="lineno">    2</span>&#160;<span class="comment">//  UIView+KKLBadgeView.m</span></div>
<div class="line"><a name="l00003"></a><span class="lineno">    3</span>&#160;<span class="comment">//  KKLOnLine</span></div>
<div class="line"><a name="l00004"></a><span class="lineno">    4</span>&#160;<span class="comment">//</span></div>
<div class="line"><a name="l00005"></a><span class="lineno">    5</span>&#160;<span class="comment">//  Created by 江俊辰 on 2017/9/20.</span></div>
<div class="line"><a name="l00006"></a><span class="lineno">    6</span>&#160;<span class="comment">//  Copyright © 2017年 mistong. All rights reserved.</span></div>
<div class="line"><a name="l00007"></a><span class="lineno">    7</span>&#160;<span class="comment">//</span></div>
<div class="line"><a name="l00008"></a><span class="lineno">    8</span>&#160; </div>
<div class="line"><a name="l00009"></a><span class="lineno">    9</span>&#160;<span class="preprocessor">#import &quot;<a class="code" href="_u_i_view_09_k_k_l_badge_view_8h.html">UIView+KKLBadgeView.h</a>&quot;</span></div>
<div class="line"><a name="l00010"></a><span class="lineno">   10</span>&#160;<span class="preprocessor">#import &lt;objc/runtime.h&gt;</span></div>
<div class="line"><a name="l00011"></a><span class="lineno">   11</span>&#160;<span class="preprocessor">#import &lt;KKLThirdParty/Masonry.h&gt;</span></div>
<div class="line"><a name="l00012"></a><span class="lineno">   12</span>&#160; </div>
<div class="line"><a name="l00013"></a><span class="lineno"><a class="line" href="category_u_i_view_07_k_k_l_badge_view_08.html#a2976a4bb937bde16cae0fc6f4cd78e7a">   13</a></span>&#160;<span class="keyword">static</span> <span class="keywordtype">char</span> sBadgeViewKey;</div>
<div class="line"><a name="l00014"></a><span class="lineno">   14</span>&#160; </div>
<div class="line"><a name="l00015"></a><span class="lineno">   15</span>&#160;<span class="keyword">@implementation </span><a class="code" href="category_u_i_view_07_k_k_l_badge_view_08.html">UIView (KKLBadgeView)</a></div>
<div class="line"><a name="l00016"></a><span class="lineno">   16</span>&#160; </div>
<div class="line"><a name="l00017"></a><span class="lineno">   17</span>&#160;- (__kindof UIView *)kkl_badgeView {</div>
<div class="line"><a name="l00018"></a><span class="lineno">   18</span>&#160;    <span class="keywordflow">return</span> [<span class="keyword">self</span> __badgeView];</div>
<div class="line"><a name="l00019"></a><span class="lineno">   19</span>&#160;}</div>
<div class="line"><a name="l00020"></a><span class="lineno">   20</span>&#160; </div>
<div class="line"><a name="l00021"></a><span class="lineno">   21</span>&#160;- (UIView *)__badgeView {</div>
<div class="line"><a name="l00022"></a><span class="lineno">   22</span>&#160;    <span class="keywordflow">return</span> objc_getAssociatedObject(<span class="keyword">self</span>, &amp;sBadgeViewKey);</div>
<div class="line"><a name="l00023"></a><span class="lineno">   23</span>&#160;}</div>
<div class="line"><a name="l00024"></a><span class="lineno">   24</span>&#160; </div>
<div class="line"><a name="l00025"></a><span class="lineno">   25</span>&#160;- (void)__setBadgeView:(UIView *)badgeView {</div>
<div class="line"><a name="l00026"></a><span class="lineno">   26</span>&#160;    UIView *oldBadgeView = [<span class="keyword">self</span> __badgeView];</div>
<div class="line"><a name="l00027"></a><span class="lineno">   27</span>&#160;    <span class="keywordflow">if</span> (oldBadgeView) {</div>
<div class="line"><a name="l00028"></a><span class="lineno">   28</span>&#160;        [oldBadgeView removeFromSuperview];</div>
<div class="line"><a name="l00029"></a><span class="lineno">   29</span>&#160;    }</div>
<div class="line"><a name="l00030"></a><span class="lineno">   30</span>&#160;    <span class="keywordflow">if</span> (badgeView) {</div>
<div class="line"><a name="l00031"></a><span class="lineno">   31</span>&#160;        objc_setAssociatedObject(<span class="keyword">self</span>, &amp;sBadgeViewKey, badgeView, OBJC_ASSOCIATION_RETAIN_NONATOMIC);</div>
<div class="line"><a name="l00032"></a><span class="lineno">   32</span>&#160;        [<span class="keyword">self</span> addSubview:badgeView];</div>
<div class="line"><a name="l00033"></a><span class="lineno">   33</span>&#160;    }</div>
<div class="line"><a name="l00034"></a><span class="lineno">   34</span>&#160;}</div>
<div class="line"><a name="l00035"></a><span class="lineno">   35</span>&#160; </div>
<div class="line"><a name="l00036"></a><span class="lineno">   36</span>&#160;- (void)removeCurrentBadgeView {</div>
<div class="line"><a name="l00037"></a><span class="lineno">   37</span>&#160;    [<span class="keyword">self</span> __setBadgeView:nil];</div>
<div class="line"><a name="l00038"></a><span class="lineno">   38</span>&#160;    </div>
<div class="line"><a name="l00039"></a><span class="lineno">   39</span>&#160;}</div>
<div class="line"><a name="l00040"></a><span class="lineno">   40</span>&#160; </div>
<div class="line"><a name="l00041"></a><span class="lineno">   41</span>&#160;- (void)setBadgeView:(UIView *)badgeView size:(CGSize)size alignment:(KKLBadgeViewAlignment)alignment insets:(UIEdgeInsets)insets {</div>
<div class="line"><a name="l00042"></a><span class="lineno">   42</span>&#160;    [<span class="keyword">self</span> __setBadgeView:badgeView];</div>
<div class="line"><a name="l00043"></a><span class="lineno">   43</span>&#160;    [badgeView mas_makeConstraints:^(MASConstraintMaker *make) {</div>
<div class="line"><a name="l00044"></a><span class="lineno">   44</span>&#160;        make.size.mas_equalTo(size);</div>
<div class="line"><a name="l00045"></a><span class="lineno">   45</span>&#160;        if (alignment == KKLBadgeViewAlignmentLeftTop) {</div>
<div class="line"><a name="l00046"></a><span class="lineno">   46</span>&#160;            make.top.equalTo(self).offset(insets.top);</div>
<div class="line"><a name="l00047"></a><span class="lineno">   47</span>&#160;            make.left.equalTo(self).offset(insets.left);</div>
<div class="line"><a name="l00048"></a><span class="lineno">   48</span>&#160;        } else if (alignment == KKLBadgeViewAlignmentRightTop) {</div>
<div class="line"><a name="l00049"></a><span class="lineno">   49</span>&#160;            make.top.equalTo(self).offset(insets.top);</div>
<div class="line"><a name="l00050"></a><span class="lineno">   50</span>&#160;            make.right.equalTo(self).offset(-insets.right);</div>
<div class="line"><a name="l00051"></a><span class="lineno">   51</span>&#160;        } else if (alignment == KKLBadgeViewAlignmentLeftBottom) {</div>
<div class="line"><a name="l00052"></a><span class="lineno">   52</span>&#160;            make.top.equalTo(self).offset(insets.left);</div>
<div class="line"><a name="l00053"></a><span class="lineno">   53</span>&#160;            make.right.equalTo(self).offset(-insets.bottom);</div>
<div class="line"><a name="l00054"></a><span class="lineno">   54</span>&#160;        }</div>
<div class="line"><a name="l00055"></a><span class="lineno">   55</span>&#160;    }];</div>
<div class="line"><a name="l00056"></a><span class="lineno">   56</span>&#160;}</div>
<div class="line"><a name="l00057"></a><span class="lineno">   57</span>&#160; </div>
<div class="line"><a name="l00058"></a><span class="lineno">   58</span>&#160;<span class="keyword">@end</span></div>
</div><!-- fragment --></div><!-- contents -->
</div><!-- doc-content -->
<div class="ttc" id="a_u_i_view_09_k_k_l_badge_view_8h_html"><div class="ttname"><a href="_u_i_view_09_k_k_l_badge_view_8h.html">UIView+KKLBadgeView.h</a></div></div>
<div class="ttc" id="acategory_u_i_view_07_k_k_l_badge_view_08_html"><div class="ttname"><a href="category_u_i_view_07_k_k_l_badge_view_08.html">UIView(KKLBadgeView)</a></div><div class="ttdef"><b>Definition:</b> <a href="_u_i_view_09_k_k_l_badge_view_8h_source.html#l00018">UIView+KKLBadgeView.h:18</a></div></div>
<!-- start footer part -->
<div id="nav-path" class="navpath"><!-- id is needed for treeview function! -->
  <ul>
    <li class="navelem"><a class="el" href="dir_05f730b1f29a3e373a3d04cb5cb42ea7.html">XHXKit</a></li><li class="navelem"><a class="el" href="dir_2d533305e802e0a7e844b4ecd2e2bdb2.html">Classes</a></li><li class="navelem"><a class="el" href="dir_171c39b2a2b35fab3d93e826831e70cd.html">General</a></li><li class="navelem"><a class="el" href="dir_0a8ba05fb147062574fff2be58e33f1d.html">Category</a></li><li class="navelem"><a class="el" href="_u_i_view_09_k_k_l_badge_view_8m.html">UIView+KKLBadgeView.m</a></li>
    <li class="footer">制作者
    <a href="http://www.doxygen.org/index.html">
    <img class="footer" src="doxygen.png" alt="doxygen"/></a> 1.8.18 </li>
  </ul>
</div>
</body>
</html>
